<template>
  <div class="w-full h-full flex flex-col gap-2">
    <Spinner v-if="status == 'loading'" />
    <div class="grow">
      <iframe ref="viewer" class="w-full h-full" />
    </div>

    <div class="flex flex-row gap-2 justify-end">
      <a ref="download" button primary class="!w-fit">download</a>
      <button primary-outline class="!w-fit" @click="closeModal">schließen</button>
    </div>

  </div>
</template>

<script setup lang="ts">
import { defineComponent } from "vue";
import { mapState, mapActions } from "pinia";
import { useModalStore } from "@/stores/modal";
import Spinner from "@/components/Spinner.vue";
import type { AxiosResponse } from "axios";
import { useMemberStore } from "@/stores/admin/club/member/member";
</script>

<script lang="ts">
export default defineComponent({
  data() {
    return {
      status: null as null | "loading" | { status: "success" | "failed"; reason?: string },
    };
  },
  computed: {
    ...mapState(useModalStore, ["data"]),
  },
  mounted() {
    this.fetchItem();
  },
  methods: {
    ...mapActions(useModalStore, ["closeModal"]),
    ...mapActions(useMemberStore, ["printMemberList"]),
    fetchItem() {
      this.status = "loading";
      this.printMemberList()
        .then((response) => {
          this.status = { status: "success" };
          const blob = new Blob([response.data], { type: "application/pdf" });
          (this.$refs.viewer as HTMLIFrameElement).src = window.URL.createObjectURL(blob);

          const fileURL = window.URL.createObjectURL(new Blob([response.data]));
          const fileLink = (this.$refs.download as HTMLAnchorElement)
          fileLink.href = fileURL;
          fileLink.setAttribute("download", "Mitgliederliste.pdf");
        })
        .catch(() => {
          this.status = { status: "failed" };
        });
    },
  },
});
</script>
